
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 MediumVioletRed
#property indicator_color2 White
#property indicator_color3 DodgerBlue

//
//
//
//
//

extern int    timeFrame       = 0;
extern bool   Show.Boxes      = true ;
extern bool   Show.Labels     = true ;
extern int    ShiftLabel      =  10 ; 
extern int    Line_Style      = STYLE_SOLID ;
extern int    Line_Width      = 0 ;
extern color  Line_Color_Open = White ;
extern color  Line_Color_High = MediumVioletRed ;
extern color  Line_Color_Low  = DodgerBlue ;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsOnHighLow = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double HiBuff[];
double OpBuff[];
double LoBuff[];
double trend[];
string TAG = "ohlp" ;

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,HiBuff); SetIndexStyle(0,DRAW_LINE,Line_Style,Line_Width,Line_Color_High);
   SetIndexBuffer(1,OpBuff); SetIndexStyle(1,DRAW_LINE,Line_Style,Line_Width,Line_Color_Open);
   SetIndexBuffer(2,LoBuff); SetIndexStyle(2,DRAW_LINE,Line_Style,Line_Width,Line_Color_Low);
   SetIndexBuffer(3,trend);
   
   IndicatorShortName("Prev Hi-Lo levels");
return(0);
}
   
//
//
//
//
//

int deinit() 
{
    ObDeleteObjectsByPrefix(TAG);  
    LBL() ; 
   
   return(0);
   
}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   
   //
   //
   //
   //
   //
   
   for (int i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         HiBuff[i] = iHigh(NULL,timeFrame,y); 
         LoBuff[i] =  iLow(NULL,timeFrame,y);
         OpBuff[i] = iOpen(NULL,timeFrame,y);
     
         trend[i] = 0;                     
            if (alertsOnHighLow)       
            {
               if (High[i] >= HiBuff[i+1])  trend[i] = -1;
               if (Low[i]  <= LoBuff[i+1])  trend[i] =  1;
            }
            else
            {
               if (Close[i] >= HiBuff[i+1]) trend[i] = -1;
               if (Close[i] <= LoBuff[i+1]) trend[i] =  1;
            }
         
     }
     
     //
     //
     //
     //
     //
     
     drawLine(HiBuff[0] ,"hi"+y,Line_Color_High,Line_Style,Line_Width,Time[0], " High["+y+"]" ) ;
     drawLine(LoBuff[0] ,"lo"+y,Line_Color_Low, Line_Style,Line_Width,Time[0], " Low["+y+"]"  ) ;
     drawLine(OpBuff[0] ,"op"+y,Line_Color_Open,Line_Style,Line_Width,Time[0], " Open["+y+"]" ) ;
     if (alertsOn)
     {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend[whichBar] != trend[whichBar+1])
       if (trend[whichBar] == 1)
             doAlert("Lower channel");
       else  doAlert("Upper channel");       
    }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrame+" OHL penetrating ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," OHL "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//
//
//
//
//

void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string text)
{ 
 
   if(Show.Labels)
   {         
      string Obj0002 = TAG+name+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      } // if 
                 
   } // if   

   if(Show.Boxes)
   {  
     string dName = TAG+name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
 
}
  

//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
void LBL()
{   
   
   string tObjName03    = "LBLTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//
//
//
//
//

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
 
           